"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert = require("assert");
const StrongBus = require("strongbus");
const DefaultRegistry = require("undertaker-registry");
const asyncDone = require("async-done");
const core_decorators_1 = require("core-decorators");
const taskContext_1 = require("./taskContext");
const taskTracker_1 = require("./taskTracker");
let Registry = class Registry extends DefaultRegistry {
    constructor(config) {
        super();
        this.eventbus = new StrongBus.Bus();
        assert(typeof config.rootPath === 'string', 'rootPath must be defined in Registry options');
        this.context = new taskContext_1.TaskContext(config, this.eventbus);
    }
    init(gulp) {
        super.init(gulp);
        // hackish
        this.gulp = gulp;
        /* tslint:disable-next-line */
        const tracker = new taskTracker_1.TaskTracker(gulp, this.eventbus);
    }
    // lazily load task dependencies so task definitions at higher levels are injected as part of lower level chains
    inject(taskname) {
        const lazy = (done) => asyncDone(this.gulp.registry().get(taskname), done);
        lazy.displayName = `[injected] ${taskname}`;
        return lazy;
    }
    override(taskname, override) {
        const original = this.gulp.registry().get(taskname) || ((d) => d());
        const overridden = (done) => asyncDone(override(original), done);
        overridden.displayName = `[overriden] ${taskname}`;
        this.gulp.task(taskname, overridden);
    }
};
Registry = __decorate([
    core_decorators_1.autobind
], Registry);
exports.Registry = Registry;
