/// <reference types="node" />
import { ChildProcess } from 'child_process';
import * as StrongBus from 'strongbus';
import { RegistryEvents } from './events';
export interface ContextConfig {
    rootPath: string;
    buildDir?: string;
    webpackConfigPath?: string;
}
export declare class TaskContext<TConfig extends ContextConfig = ContextConfig> {
    private childProcesses;
    private teardowns;
    private commands;
    readonly config: TConfig;
    registerCommand: (command: string, contextCommand: import("./contextCommands").ContextCommand) => void;
    constructor(config: TConfig, bus: StrongBus.Bus<RegistryEvents>);
    registerChildProcess(child: ChildProcess, options?: {
        silent?: boolean;
    }): void;
    onExit(cb: () => void): void;
    private exit;
    private exitGracefully;
}
