"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_decorators_1 = require("core-decorators");
let TaskTracker = class TaskTracker {
    constructor(gulp, bus) {
        this.runningTasks = new Map();
        this.exited = false;
        this.bus = bus;
        gulp
            .on('start', this.add)
            .on('start', (event) => this.bus.emit('gulp_task_start', event))
            .on('stop', (event) => this.bus.emit('gulp_task_stop', event))
            .on('stop', this.remove);
    }
    add({ uid, name }) {
        if (this.runningTasks.size === 0) {
            this.bus.emit('gulp_start', null);
        }
        this.runningTasks.set(uid, name);
    }
    remove({ uid }) {
        this.runningTasks.delete(uid);
        setTimeout(() => {
            if (!this.exited && this.runningTasks.size === 0) {
                this.bus.emit('gulp_done', null);
                this.exited = true;
                process.exit();
            }
        }, 500);
    }
};
TaskTracker = __decorate([
    core_decorators_1.autobind
], TaskTracker);
exports.TaskTracker = TaskTracker;
